/*
 * Copyright (c) 2024 Qualcomm Innovation Center, Inc. All rights reserved.
 * SPDX-License-Identifier: BSD-3-Clause-Clear
 */

#ifndef UA_PLUGIN_H
#define UA_PLUGIN_H

//--------------------------------------------------------------------------------------------------
/**
 * Maximum bytes of file path.
 */
//--------------------------------------------------------------------------------------------------
#define FILE_PATH_MAX_BYTES 256

//--------------------------------------------------------------------------------------------------
/**
 * Maximum bytes of string.
 */
//--------------------------------------------------------------------------------------------------
#define STR_MAX_BYTES 1024

//--------------------------------------------------------------------------------------------------
/**
 * Maximum bytes of volume name.
 */
//--------------------------------------------------------------------------------------------------
#define VOL_NAME_MAX_BYTES 32

//--------------------------------------------------------------------------------------------------
/**
 * Time for unpacking.
 */
//--------------------------------------------------------------------------------------------------
#define UNPACK_TIME 5

//--------------------------------------------------------------------------------------------------
/**
 * Time for updating TelAF.
 */
//--------------------------------------------------------------------------------------------------
#define UPDATE_TELAF_TIME 7

//--------------------------------------------------------------------------------------------------
/**
 * Time for updating RootFS.
 */
//--------------------------------------------------------------------------------------------------
#define UPDATE_ROOTFS_TIME 56

//--------------------------------------------------------------------------------------------------
/**
 * Update session number.
 */
//--------------------------------------------------------------------------------------------------
#define UA_SESSION_NUM 1

//--------------------------------------------------------------------------------------------------
/**
 * Page size.
 */
//--------------------------------------------------------------------------------------------------
#define PAGE_SIZE 4096

//--------------------------------------------------------------------------------------------------
/**
 * UBI volume name path.
 */
//--------------------------------------------------------------------------------------------------
#define UBI_VOL_NAME_PATH  "/sys/class/ubi/ubi0_%d/name"

//--------------------------------------------------------------------------------------------------
/**
 * UBI volume size path.
 */
//--------------------------------------------------------------------------------------------------
#define UBI_VOL_SIZE_PATH  "/sys/class/ubi/ubi0_%d/data_bytes"

//--------------------------------------------------------------------------------------------------
/**
 * UBI volume device path.
 */
//--------------------------------------------------------------------------------------------------
#define UBI_VOL_DEV_PATH  "/dev/ubi0_%d"

//--------------------------------------------------------------------------------------------------
/**
 * UBI volume count path.
 */
//--------------------------------------------------------------------------------------------------
#define UBI_VOL_COUNT_PATH "/sys/class/ubi/ubi0/volumes_count"

//--------------------------------------------------------------------------------------------------
/**
 * Unzip to data.
 */
//--------------------------------------------------------------------------------------------------
#define UNZIP_TO_DATA "unzip -d /data %s"

//--------------------------------------------------------------------------------------------------
/**
 * Perform delta.
 */
//--------------------------------------------------------------------------------------------------
#define PERFORM_DELTA "/app/xdelta3 -d -s %s %s %s"

//--------------------------------------------------------------------------------------------------
/**
 * Pause flag.
 */
//--------------------------------------------------------------------------------------------------
#define PAUSE_ACTION "/data/action"

//--------------------------------------------------------------------------------------------------
/**
 * Sync file system.
 */
//--------------------------------------------------------------------------------------------------
#define SYNC_FS "sync"

//--------------------------------------------------------------------------------------------------
/**
 * Get active slot.
 */
//--------------------------------------------------------------------------------------------------
#define GET_ACTIVE_SLOT "nad-abctl --boot_slot"

//--------------------------------------------------------------------------------------------------
/**
 * Set active slot.
 */
//--------------------------------------------------------------------------------------------------
#define SET_ACTIVE_SLOT "nad-abctl --set_active %d"

//--------------------------------------------------------------------------------------------------
/**
 * Update action enum.
 */
//--------------------------------------------------------------------------------------------------
typedef enum
{
    START_INSTALL,
    PAUSE_INSTALL,
    RESUME_INSTALL
} taf_pi_ua_Action;

//--------------------------------------------------------------------------------------------------
/**
 * Update process enum.
 */
//--------------------------------------------------------------------------------------------------
typedef enum
{
    INIT_SESSION,
    UNPACK_PACKAGE,
    GET_BOOT_SLOT,
    INIT_FLASH_INFO,
    APPLY_TELAF_PATCH,
    APPLY_ROOTFS_PATCH,
    SET_ACTIVE
} taf_pi_ua_Process;

//--------------------------------------------------------------------------------------------------
/**
 * Partition information structure.
 */
//--------------------------------------------------------------------------------------------------
typedef struct
{
    bool validPatch;
    int srcFd;
    int tgtFd;
    uint32_t volSize;
    char srcPartName[VOL_NAME_MAX_BYTES];
    char tgtPartName[VOL_NAME_MAX_BYTES];
    char srcPath[FILE_PATH_MAX_BYTES];
    char tgtPath[FILE_PATH_MAX_BYTES];
    char patchPath[FILE_PATH_MAX_BYTES];
} taf_pi_ua_PartitionInfo;

//--------------------------------------------------------------------------------------------------
/**
 * Flash information structure.
 */
//--------------------------------------------------------------------------------------------------
typedef struct
{
    taf_pi_ua_PartitionInfo telaf;
    taf_pi_ua_PartitionInfo rootfs;
    bool isBootOnA;
} taf_pi_ua_FlashInfo;

//--------------------------------------------------------------------------------------------------
/**
 * Update command structure.
 */
//--------------------------------------------------------------------------------------------------
typedef struct
{
    taf_pi_ua_Action action;
    char filePath[FILE_PATH_MAX_BYTES];
} ua_Command_t;

//--------------------------------------------------------------------------------------------------
/**
 * Update session structure.
 */
//--------------------------------------------------------------------------------------------------
typedef struct
{
    char deltaPath[FILE_PATH_MAX_BYTES];
    ua_Command_t cmd;
    taf_pi_ua_FlashInfo flashInfo;
    taf_pi_ua_Process process;
} taf_pi_ua_Session;

#endif